// 1ページ当たりの記事数
var per_page = 5;
// ページ番号
var page_no = 1;
// JavaScriptライブラリの初期化
var api = new MT.DataAPI({
  baseUrl:  '<$mt:CGIPath$>mt-data-api.cgi',
  clientId: 'example'
});
// ページの表示
renderPage(page_no);

function renderPage() {
  // 「読み込み中です」のメッセージの出力
  jQuery('#contents').html('<p>読み込み中です</p>');
  // 読み込みオプションの定義
  var offset = (page_no - 1) * per_page;
  var params = {
    offset: offset,
    limit: per_page,
    fields: 'title,date,excerpt'
  };
  // 記事の読み込み
  api.listEntries(<$mt:BlogID$>, params, function(response) {
    var html = '';
    var page_count = Math.floor((response.totalResults - 1) / per_page) + 1;
    var entries = response.items;
    // 記事の範囲を出力する
    var offset_end = (page_no == page_count) ? response.totalResults : offset + per_page;
    html += '<p>' + response.totalResults + '件中' + (offset + 1) + '～' + offset_end + '件目</p>';
    // 記事のタイトルと概要を出力する
    html += '<ul>';
    for (var i = 0, j = entries.length; i < j; i++) {
      var dt = new Date(entries[i].date);
      html += '<li><h2>' + entries[i].title + '</h2>';
      html += '<p>' + (dt.getYear() + 1900) + '年' + dt.getMonth() + '月' + dt.getDate() + '日';
      html += '<p>' + entries[i].excerpt + '</p></li>';
    }
    html += '</ul>';
    // 各ページへのリンクを出力する
    html += '<ul id="pagination">';
    for (i = 1; i <= page_count; i++) {
      if (i == page_no) {
        html += '<li class="current">' + i + '</li>';
      }
      else {
        html += '<li><a href="#">' + i + '</a></li>';
      }
    }
    html += '</ul>';
    jQuery('#contents').html(html);
    // ページ移動リンクがクリックされたときの処理
    jQuery('#pagination li a').on('click', function() {
      page_no = jQuery(this).html();
      renderPage();
    });
  });
}
